
Core - Bug # 63670

Bug # 63692 (Accepted): Memory consumption while bulk inserting

Status: Resolved Priority: Must have
Author: Stephan Großberndt Category: Performance
Created: 2014-12-08 Assigned To:
Updated: 2015-03-31 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Is Regression: No
Sprint Focus:
Subject: High memory consumption in DataHandler->checkValue_input while bulk inserting
Description

In DataHandler->checkValue_input for each input value of each record to insert is executed.

// Process evaluation settings:
$evalCodesArray = GeneralUtility::trimExplode(',', $tcaFieldConf['eval'], TRUE);

While this may seem minor introducing a cache here helps:

public function checkValue_input($res, $value, $tcaFieldConf, $PP, $field = '') {
    static $evalCodesCache = array();

    [...]
    // Process evaluation settings:
    if ($evalCodesCache[$tcaFieldConf['eval']]) {
        $evalCodesArray = $evalCodesCache[$tcaFieldConf['eval']];
    } else {
        $evalCodesArray = GeneralUtility::trimExplode(',', $tcaFieldConf['eval'], TRUE);
        $evalCodesCache[$tcaFieldConf['eval']] = $evalCodesArray;
    }

For bulk inserting of 6500 records:
    -  2 calls instead of 44646 to trimExplode from this function
    -  0.7 sec faster
    -  memory_usage of trimExplode down by 17MB

Associated revisions
Revision 5acee1d3 - 2015-03-18 21:25 - Stephan Großberndt

[BUGFIX] DataHandler: Cache TCA field eval array

Introduce a runtime cache for the eval values of TCA input and text
fields. This improves performance for bulk inserts since
DataHandler->checkValue_input and checkValue_text are called for each
according field of each record and the available evaluations do not
change during a call. If no eval is set, do not execute
checkValue_*_Eval functions at all.
Additionally align usages of getMemoryCache() to runtimeCache and
keys of nestedElementCalls and elementsToBeDeleted in cache_runtime.

Resolves: #63670
Releases: master, 6.2
Change-Id: I3d2122a61e3194402743fa0b364d6bd80d4e72dc
Reviewed-on: http://review.typo3.org/35186
Reviewed-by: Nicole Cordes <typo3@cordes.co>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>
Reviewed-by: Jigal van Hemert <jigal.van.hemert@typo3.org>
Tested-by: Jigal van Hemert <jigal.van.hemert@typo3.org>

Revision 4a9e5fdb - 2015-03-19 00:24 - Nicole Cordes

[FOLLOWUP][BUGFIX] DataHandler: Cache TCA field eval array

This fixes failing functional tests.

Resolves: #63670
Releases: master
Change-Id: Ief6ec0d6a1d2f45a7b8cb512741af722807aad9d
Reviewed-on: http://review.typo3.org/37937
Reviewed-by: Stephan Großberndt <stephan@grossberndt.de>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>

Revision c1bb6311 - 2015-03-31 18:53 - Stephan Großberndt

[BUGFIX] DataHandler: Cache TCA field eval array

Introduce a runtime cache for the eval values of TCA input and text
fields. This improves performance for bulk inserts since
DataHandler->checkValue_input and checkValue_text are called for each
according field of each record and the available evaluations do not
change during a call. If no eval is set, do not execute
checkValue_*_Eval functions at all.

Additionally align usages of getMemoryCache() to runtimeCache and
keys of nestedElementCalls and elementsToBeDeleted in cache_runtime.

Resolves: #63670
Releases: master, 6.2
Change-Id: I3d2122a61e3194402743fa0b364d6bd80d4e72dc
Reviewed-on: http://review.typo3.org/37963
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>

History
#1 - 2014-12-09 07:03 - Philipp Gampe
- Parent task set to #63692

#2 - 2014-12-09 12:51 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#3 - 2014-12-09 13:14 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#4 - 2014-12-09 13:35 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#5 - 2014-12-11 10:42 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#6 - 2014-12-11 10:44 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#7 - 2014-12-11 11:35 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#8 - 2014-12-11 13:56 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#9 - 2014-12-24 01:22 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#10 - 2015-01-05 15:40 - Gerrit Code Review
Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#11 - 2015-01-05 16:39 - Stephan Großberndt
- File eval.txt added

#12 - 2015-01-10 00:53 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#13 - 2015-01-11 13:44 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#14 - 2015-01-16 12:45 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#15 - 2015-01-21 13:48 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#16 - 2015-01-28 01:47 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#17 - 2015-03-05 20:33 - Gerrit Code Review

Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35186

#18 - 2015-03-18 21:31 - Stephan Großberndt
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:5acee1d3cec4dd807d41800a9bc4b82faf80286c.

#19 - 2015-03-18 22:44 - Gerrit Code Review
- Status changed from Resolved to Under Review
Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37937

#20 - 2015-03-18 23:17 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37937

#21 - 2015-03-18 23:25 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37937

#22 - 2015-03-19 00:30 - Nicole Cordes
- Status changed from Under Review to Resolved

Applied in changeset commit:4a9e5fdb0f5ef41f5eed88200b906a4a800300b4.

#23 - 2015-03-19 20:52 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37963

#24 - 2015-03-31 19:00 - Stephan Großberndt
- Status changed from Under Review to Resolved

Applied in changeset commit:c1bb6311afc3477e449460193eda3a6c6826d38d.

Files
eval.txt 7.7 kB 2015-01-05 Stephan Großberndt
